Unit DE26R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE33R_p, DE28RP_p, DE28RS_p, UTDE12_p;

procedure DE26R(F :Proc_F70; M :Integer; var JSTART :Integer;
                var YX :Array of Real; var X :Real; H :Real;
                var DELTY :Array of Real; var DF :Array of Real;
                var RF :Array of Real; var YP :Array of Real;
                var RY :Array of Real; var RFN :Array of Real;
                var IERR :Integer);

implementation

procedure DE26R(F :Proc_F70; M :Integer; var JSTART :Integer;
                var YX :Array of Real; var X :Real; H :Real;
                var DELTY :Array of Real; var DF :Array of Real;
                var RF :Array of Real; var YP :Array of Real;
                var RY :Array of Real; var RFN :Array of Real;
                var IERR :Integer);
var
I,K,K1 :Integer;
ALP :Real;
BUL2 :Boolean;
RX :Array [0..4] of Real;
const
C1 :Real = 0.5e0;
C2 :Real = 0.4166666666666667e0;
C3 :Real = 0.375e0;
C4 :Real = -0.02638888888888889e0;
IMAX :Integer = 6;
P :Real = 0.01;
EPS :Real = 0.0000001;
IORDER :Integer = 5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
if ( JSTART >= 0 )
 then goto _3;
if ( IERR = 0 )
 then goto _1;
IERR := 0;
goto _5;
_1:
for K:=1 to 4 do
 begin
  K1 := K+1;
  for I:=1 to M do
   begin
    DF[(I-1)+(K-1)*M] := DF[(I-1)+(K-1)*M]-DF[(I-1)+(K1-1)*M];
_2:
   end;
 end;
goto _5;
_3:
_COM26R.elm2 := X;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_4:
 end;
IERR := 0;
if ( JSTART <> 0 )
 then goto _5;
F(X,YX,RF,M);
DE33R(F,M,IORDER,X,YX,H,DF,RX,RY,RFN,RF,DELTY,I);
goto _6;
_5:
if ( H = _COM26R.elm1 )
 then goto _6;
ALP := H/_COM26R.elm1;
DE28RP(M,IORDER,ALP,DF);
_6:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1]+DF[(I-1)+0*M]+DF[(I-1)+1*M]*C1+DF[(I-1)+2*M]*C2+DF[(I-1)+3*M]*C3;
  RF[I-1] := DF[(I-1)+0*M]+DF[(I-1)+1*M]+DF[(I-1)+2*M]+DF[(I-1)+3*M];
_7:
 end;
X := _COM26R.elm2+H;
for K:=1 to IMAX do
 begin
  BUL2 :=True;
  for I:=1 to M do
   begin
    DELTY[I-1] := -RF[I-1]*C3;
_8:
   end;
  F(X,YX,RF,M);
  for I:=1 to M do
   begin
    RF[I-1] := RF[I-1]*H;
    DELTY[I-1] := DELTY[I-1]+RF[I-1]*C3;
    YX[I-1] := DELTY[I-1]+YX[I-1];
    if ( Abs(YX[I-1]) <= P )
     then goto _9;
    DELTY[I-1] := DELTY[I-1]/YX[I-1];
_9:
    if ( Abs(DELTY[I-1]) > EPS )
     then BUL2 :=False;
_10:
   end;
  if ( BUL2 ) 
   then goto _13;
_11:
 end;
IERR := 65;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_12:
 end;
X := _COM26R.elm2;
goto _15;
_13:
DE28RS(M,IORDER,RF,DF,DELTY);
for I:=1 to M do
 begin
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  YX[I-1] := YX[I-1]+DELTY[I-1];
_14:
 end;
_15:
if ( IERR <> 0 ) 
 then UTDE12(IERR,26);
JSTART := 1;
_COM26R.elm1 := H;
end;

end.
